public class PileListe implements IPile {

	/**
	 * Classe interne pour la représentation
	 * de la liste chaînée
	 */
    class Maillon {
        protected Maillon prec;
        protected Object objet;

        public Maillon() {

            prec = this;
            objet = null;

        }

        public Maillon( Object objet ) {

            prec = this;
            this.objet = objet;

        }


        void setPrec( Maillon m ) {
            prec = m;
        }

        Maillon getPrec() {
            return prec;
        }

        Object getObjet() {
            return objet;
        }
        
    }

	// implantation de la pile sous forme d'une liste
	// simplement chaînée
    protected Maillon premier;
    protected int taille;
    
	/**
	 * Constructeur par défaut
	 */
    public PileListe() {
    
        premier = null;
        taille = 0;
        
    }


    public void empiler( Object o ) throws Exception {
    
        Maillon nouveau = new Maillon( o );
        
        nouveau.setPrec( premier );
        premier = nouveau ;

		++taille;
		
    }

    public void depiler( ) throws Exception {

        if (premier == null) {
            throw new Exception( "Pile vide" );

        } else {

            premier = premier.getPrec();

			--taille;
        }
    }
    

    public Object sommet( ) throws Exception {

        if (premier == null) {
            throw new Exception("Pile vide");
            
        } else {
        
            return premier.getObjet();
            
        }
    }

    public boolean estVide( ) {

        return premier == null;

    }


    public String toString() {
        String s = "";
        Maillon courant = premier;
        if (courant != null) {
        	while (courant != null) {
                s += " " + courant.getObjet().toString();
                courant = courant.getPrec();
            } 
        }
        return s;
    }
}
