public class TestPileTableau {

	/**
	 * Première version de viderEtSommer avec une PileTableau
	 *
	 */
    public static int viderEtSommer_v1( PileTableau pile ) throws Exception {

        int total = 0;
        while (! pile.estVide() ) {
            Object o = pile.sommet();
            pile.depiler();
            if (o instanceof Integer) {
                total += ((Integer) o).intValue();
            }
        }

        return total;
    }
    
	/**
	 * Deuxième version de viderEtSommer avec une interface
	 *
	 */
    public static int viderEtSommer_v2( IPile pile ) throws Exception {

        int total = 0;
        while (! pile.estVide() ) {
            Object o = pile.sommet();
            pile.depiler();
            if (o instanceof Integer) {
                total += ((Integer) o).intValue();
            }
        }

        return total;
    }
    
    
    

    public static void main( String args[] ) {

		// Utilisation de la PileTableau pour réaliser viderEtSommer
        try {
        	System.out.println( "--------------------------------" );
        	System.out.println( " Manipulation d'une PileTableau " );
        	System.out.println( "--------------------------------" );
            
            PileTableau maPile = new PileTableau(11);
            for (int i = 1; i <= 11; ++i) {
                maPile.empiler( Integer.valueOf( i ) );
            }

            System.out.println( "pile = " + maPile );
            System.out.println( "somme (v1) = " + viderEtSommer_v1( maPile ) );
            System.out.println( "vide ? = " + maPile.estVide() );

        } catch( Exception e) {
            System.err.println( e );
        }

		// Utilisation de l'interface pour réaliser viderEtSommer
        try {
        	System.out.println( "--------------------------------" );
        	System.out.println( " Manipulation d'une PileTableau " );
        	System.out.println( "      grâce à son interface     " );
        	System.out.println( "--------------------------------" );
        	
            IPile maPile = new PileTableau(11);
            for (int i = 1; i <= 11; ++i) {
                maPile.empiler( Integer.valueOf( i ) );
            }

            System.out.println( "pile = " + maPile );
            System.out.println( "somme (v2) = " + viderEtSommer_v2( maPile ) );
            System.out.println( "vide ? = " + maPile.estVide() );

        } catch( Exception e) {
            System.err.println( e );
        }

    }

}
